; tabstop=8
;
;

	relaxed on

	org	$e000

	jp	STARTREAD	; 0xe000
	jp	INIT8251	; 0xe003
	jp	TXDATA		; 0xe006
	jp	READROMRAM	; 0xe009
	jp	ENDREAD		; 0xe00c
	jp	HEADTRANS	; 0xe00f
	jp	HEADCHECK	; 0xe012
	jp	ERASERAM	; 0xe015

	org	$e020

MODE8251:
	db	$4f		; 0xe020 ; stop=1/parity=none/length=8bit/clock=x64
STATUSFLAG:
	db	$00		; 0xe021 ; DSR/BD/FE/OE/PE/TXEMPTY/RXRDY/TXRDY
TXMODE:
	db	$81		; 0xe022 ; DSR=on/TxRDY=1
ACCADD:
	db	$00		; 0xe023 ; Access start address (0x00/0x40/0xA0)
C_RESULT:
	db	$00		; 0xe024 ; header check result (OK = 0x00)
RDBANK:
	dw	$0000		; 0xe025,6 ; Read bank number
MBC:
	db	$00		; 0xe027 ; MBC number
TXSIZE:
	db	$40		; 0xe028 ; Transfer size (x256 bytes)


	org	$e030
HEADBUF:
	db	$50 dup ($00)	; Header


;
; 8251ݒ
; (MODE8251)Fݒl
;
INIT8251:
	di
	ld	a,(MODE8251)
	ld	b,a
	ld	a,$12
	out	($81),a		; RTS=off/DTR=on/Tx=Disable/Rx=Disable/Error clear
	ld	a,$52
	out	($81),a		; 8251 Reset
	nop			; wait
	nop
	nop
	nop
	ld	a,b
	out	($81),a		; 8251 mode set
	ld	a,$37
	out	($81),a		; RTS=on/DTR=on/Tx=Enable/Rx=Ensable/Error clear
	ei
	ret


;
; 0x0000`̃f[^𑗐M
; (TXSIZE)FMoCgix256 bytesj
;
TXDATA:
	di
	ld	a,$02
	out	($93),a		; oXNGXgOFF
	ld	a,$dd
	out	($f0),a		; 0000H-7FFFH RAM
	ld	hl,$0000
	ld	a,(TXMODE)
	ld	d,a
.lp1:
	in	a,($81)		; get TxRDY & DSR status
	and	d
	cp	d
	jr	nz,.lp1
	ld	a,(hl)
	out	($80),a
	inc	hl
	ld	a,(TXSIZE)
	cp	h
	jr	nz,.lp1

	ld	a,$11
	out	($f0),a		; 0000H-7FFFH BASIC-ROM
	ld	a,$03
	out	($93),a		; oXNGXgON
	ei
	ret

;
; 8255̏ݒ
;
STARTREAD:
	di

	ld	a,$e9
	out	($d2),a		; nWE/nRD/nCS/CLK/nDOE/DCLK/PHI/nRES
	ld	a,$ff
	out	($d0),a		; A15-8
	ld	a,$09
	out	($d3),a		; CLK=H
	ld	a,$08
	out	($d3),a		; CLK=L
	ld	a,$05
	out	($d3),a		; DCLK
	ld	a,$04
	out	($d3),a		; DCLK
	ld	a,$06

	ld	a,$82
	out	($d3),a		; port A,C=output  port B=input
	ld	a,$e9
	out	($d2),a		; nWE/nRD/nCS/CLK/nDOE/DCLK/PHI/nRES
	ld	a,$00
	out	($d3),a		; nRES=L
	push	hl		; ԑ҂
	pop	hl		; ԑ҂
	ld	a,$01
	out	($d3),a		; nRES=H

	ld	hl,RS232C_INTVEC
	ld	($fa04),hl	; RS232C̊荞݂XLbv

RS232C_INTVEC:
	ei
	ret

;
; 8255̏I
;
ENDREAD:
	di
	ld	de,$0000	; RAM disable
	ld	l,$00		; RAM disable
	call	WRITEDATA

	ld	a,$e9
	out	($d2),a		; nWE/nRD/nCS/CLK/nDOE/DCLK/PHI/nRES
	ld	a,$ff
	out	($d0),a		; ރf[^
	ld	a,$09
	out	($d3),a		; CLK=H
	ld	a,$08
	out	($d3),a		; CLK=L
	ld	a,$ff
	out	($d0),a		; A7-0
	ld	a,$05
	out	($d3),a		; DCLK
	ld	a,$04
	out	($d3),a		; DCLK
	ld	a,$06

	ld	a,$9b
	out	($d3),a		; port A,B,C=input
	ei
	ret

;
; ROM/RAM̃f[^ǂݏo
;
READROMRAM:
	call	STARTREAD

	di

	push	ix
	call	SETBANK		; oNݒ
	pop	ix

	ld	hl,$0000	; ރAhX
	ld	a,(ACCADD)	; ANZXAhXi0x0000/0x4000/0xA000j
	ld	d,a		; AhX
	ld	e,$00		; AhX

.lp1:
	ld	a,d
	out	($d0),a		; AhX
	ld	a,$09
	out	($d3),a		; clk
	ld	a,$08
	out	($d3),a		; clk
	ld	a,e
	out	($d0),a		; AhX
	inc	de

	ld	a,(ACCADD)	; ANZXAhXi0x0000/0x4000/0xA000j
	cp	$a0
	jr	nz,.next
	ld	a,$0a
	out	($d3),a		; nCS=L
.next:
	ld	a,$0c
	out	($d3),a		; nRD=L

	push	hl		; ԑ҂
	pop	hl		; ԑ҂

	in	a,($d1)
	ld	(hl),a
	inc	hl

	ld	a,$0d
	out	($d3),a		; nRD=H
	ld	a,$0b
	out	($d3),a		; nCS=H

	ld	a,(TXSIZE)
	cp	h
	jr	nz,.lp1

	ei

	call	ENDREAD

	ret


;
; ǂݍރoNݒ肷
; (MBC)FMBC^Cv
; (ACCADD)FANZXAhXi0x00/0x40/0xA0j
; (RDBANK)FoNԍ
;
SETBANK:
	ld	a,(MBC)
	or	a
	ret	z		; MBCȂȂ烊^[
	ld	e,a

	ld	a,(ACCADD)
	or	a
	ret	z		; oN#0Ȃ烊^[
	ld	d,a

	ld	ix,BANKTBL

.lp1:
	ld	l,(ix+0)
	ld	h,(ix+1)
	ld	a,h
	or	l
	ret	z		; e[uIȂ烊^[
	sbc	hl,de
	jr	nz,.next

	ld	l,(ix+2)
	ld	h,(ix+3)
	jp	(hl)

.next:
	inc	ix
	inc	ix
	inc	ix
	inc	ix
	jr	.lp1


BANKTBL:
	dw	$4001,MBC1ROM
	dw	$a001,MBC1RAM
	dw	$4002,MBC2ROM
	dw	$a002,MBC2RAM
	dw	$4003,MBC3ROM
	dw	$a003,MBC3RAM
	dw	$4005,MBC5ROM
	dw	$a005,MBC5RAM
	dw	$4007,MBC7ROM
	dw	$40fd,TAMA5ROM
	dw	$a0fd,TAMA5RAM
	dw	$40fe,HuC3ROM
	dw	$a0fe,HuC3RAM
	dw	$40ff,HuC1ROM
	dw	$a0ff,HuC1RAM
	dw	$0000


;
; MBC1 ROM ǂݏo
;
MBC1ROM:
	ld	de,$6000	; [hؑ
	ld	l,$00		; [hؑ
	call	WRITEDATA
	ld	de,$2000	; ROMoNݒ
	ld	a,(RDBANK)
	and	$1f		; ROMoN
	ld	l,a
	call	WRITEDATA
	ld	de,$4000	; ROMoNݒ
	ld	a,(RDBANK)
	and	$60
	rlca
	rlca
	rlca			; ROMoN
	ld	l,a
	call	WRITEDATA
	ret

;
; MBC1 RAM ǂݏo
;
MBC1RAM:
	ld	de,$6000	; [hؑ
	ld	l,$01		; [hؑ
	call	WRITEDATA
	call	RAMENABLE
	ld	de,$4000	; RAMoNݒ
	ld	a,(RDBANK)
	and	$03		; RAMoN
	ld	l,a
	call	WRITEDATA
	ret

;
; MBC2 ROM ǂݏo
;
MBC2ROM:
	ld	de,$2100	; ROMoNݒ
	ld	a,(RDBANK)
	and	$0f		; ROMoN
	ld	l,a
	call	WRITEDATA
	ret

;
; MBC2 RAM ǂݏo
;
MBC2RAM:
	jp	RAMENABLE

;
; MBC3 ROM ǂݏo
;
MBC3ROM:
	ld	de,$2000	; ROMoNݒ
	ld	a,(RDBANK)
	and	$7f		; ROMoN
	ld	l,a
	call	WRITEDATA
	ret

;
; MBC3 RAM ǂݏo
;
MBC3RAM:
	call	RAMENABLE
	ld	de,$4000	; RAMoNݒ
	ld	a,(RDBANK)
	and	$03		; RAMoN
	ld	l,a
	call	WRITEDATA
	ret

;
; MBC5 ROM ǂݏo
;
MBC5ROM:
	ld	de,$2000	; ROMoNݒ
	ld	a,(RDBANK)
	ld	l,a
	call	WRITEDATA
	ld	de,$3000	; ROMoNݒ
	ld	a,(RDBANK+1)
	and	$01
	ld	l,a
	call	WRITEDATA
	ret

;
; MBC5 RAM ǂݏo
;
MBC5RAM:
	call	RAMENABLE
	ld	de,$4000	; RAMoNݒ
	ld	a,(RDBANK)
	and	$0f		; RAMoN
	ld	l,a
	call	WRITEDATA
	ret

;
; MBC7 ROM ǂݏo
;
MBC7ROM:
	jp	MBC3ROM


;
; TAMA5 ROM ǂݏo
;
TAMA5ROM:
	ld	de,$a001	; ROMoNʎw
	ld	hl,$0000
	call	WRITERAM
	ld	de,$a000	; ROMoNݒiʁj
	ld	a,(RDBANK)
	and	$0f
	ld	l,a
	ld	h,$00
	call	WRITERAM
	ld	de,$a001	; ROMoNʎw
	ld	hl,$0001
	call	WRITERAM
	ld	de,$a000	; ROMoNݒiʁj
	ld	a,(RDBANK)
	and	$10
	rlca
	rlca
	rlca
	rlca
	ld	l,a
	ld	h,$00
	call	WRITERAM
	ret

;
; TAMA5 RAM ǂݏo
;
TAMA5RAM:
	ret

;
; HuC3 ROM ǂݏo
;
HuC3ROM:
	ld	de,$2000	; ROMoNݒ
	ld	a,(RDBANK)
	ld	l,a
	call	WRITEDATA
	ret

;
; HuC3 RAM ǂݏo
;
HuC3RAM:
	call	RAMENABLE
	ld	de,$4000	; RAMoNݒ
	ld	a,(RDBANK)
	and	$0f		; RAMoN
	ld	l,a
	call	WRITEDATA
	ret

;
; HuC1 ROM ǂݏo
;
HuC1ROM:
	ld	de,$6000	; [hؑ
	ld	l,$00		; [hؑ
	call	WRITEDATA
	ld	de,$2000	; ROMoNݒ
	ld	a,(RDBANK)
	ld	l,a
	call	WRITEDATA
	ret

;
; HuC1 RAM ǂݏo
;
HuC1RAM:
	jp	MBC1RAM


;
; RAM enable
;
RAMENABLE:
	ld	de,$0000	; RAM enable
	ld	l,$0a		; RAM enable
	call	WRITEDATA
	ret

;
; f[^o
; DEF݃AhX
; LF݃f[^
; HF0x00A֏ށ^0x00ȊOAւ͏܂Ȃ
;
WRITEDATA:
	ld	h,$ff
WRITERAM:
	ld	a,l
	out	($d0),a		; ރf[^
	ld	a,$05
	out	($d3),a		; DCLK
	ld	a,$04
	out	($d3),a		; DCLK
	ld	a,$06
	out	($d3),a		; nDOE=L
	ld	a,d
	out	($d0),a		; AhX
	ld	a,$09
	out	($d3),a		; CLK
	ld	a,$08
	out	($d3),a		; CLK
	ld	a,e
	out	($d0),a		; AhX
	ld	a,h
	or	a
	jr	nz,.next
	ld	a,$0a
	out	($d3),a		; nCS=L
.next:
	ld	a,$0e
	out	($d3),a		; nWE=L
	push	hl		; ԑ҂
	pop	hl		; ԑ҂
	ld	a,$0f
	out	($d3),a		; nWE=H
	ld	a,$0b
	out	($d3),a		; nCS=H
	ld	a,$07
	out	($d3),a		; nDOE=H
	ret

;
; RAM̃f[^ix^0xFFɏ㏑j
;
ERASERAM:
	call	STARTREAD

	di

	push	ix
	call	SETBANK		; oNݒ
	pop	ix

	ld	hl,$0000	; ރAhX
	ld	a,(ACCADD)	; ANZXAhXi0x0000/0x4000/0xA000j
	ld	d,a		; AhX
	ld	e,$00		; AhX

.lp1:
	push	hl
	push	de
	ld	hl,$00ff	; H=݃tO^L=݃f[^
	call	WRITERAM
	pop	de
	pop	hl

	inc	de
	inc	hl
	ld	a,(TXSIZE)
	cp	h
	jr	nz,.lp1

	ei

	call	ENDREAD

	ret


;
; wb_f[^]
;
HEADTRANS:
	di

	ld	a,$dd
	out	($f0),a		; 0000H-7FFFH RAM

	ld	hl,$0100
	ld	de,HEADBUF
	ld	bc,$50
	ldir

	ld	a,$11
	out	($f0),a		; 0000H-7FFFH BASIC-ROM

	ei
	ret


;
; wb_f[^`FbN
;
HEADCHECK:
	ld	c,$00

	ld	hl,$0000
	ld	de,$0004+HEADBUF	; logo
	ld	b,$30
.lp1:
	ld	a,(de)
	inc	de
	add	a,l
	ld	l,a
	jr	nc,.noc1
	inc	h
.noc1:
	djnz	.lp1

	ld	de,$1546
	or	a
	sbc	hl,de
	jr	z,.next1

	set	0,c			; logo error (bit0)

.next1:
	ld	d,$00
	ld	hl,$0034+HEADBUF	; header
	ld	b,$19
.lp2:
	ld	e,(hl)
	inc	hl
	ld	a,d
	sub	e
	dec	a
	ld	d,a
	djnz	.lp2

	ld	a,(hl)
	cp	d
	jr	z,.next2

	set	1,c			; header sum error (bit1)

.next2:
	ld	a,c
	ld	(C_RESULT),a
	ret


	END

